Index: branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 437)
+++ branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 438)
@@ -2695,132 +2494,9 @@
      }               
   }
-//  assert(it != accessUnit.end());  // Triggers with some legit configurations
+  assert(it != accessUnit.end());
   return seiStartPos;
 }
 #endif
 
-#if L0386_DB_METRIC
-Void TEncGOP::dblMetric( TComPic* pcPic, UInt uiNumSlices )
-{
-  TComPicYuv* pcPicYuvRec = pcPic->getPicYuvRec();
-  Pel* Rec    = pcPicYuvRec->getLumaAddr( 0 );
-  Pel* tempRec = Rec;
-  Int  stride = pcPicYuvRec->getStride();
-  UInt log2maxTB = pcPic->getSlice(0)->getSPS()->getQuadtreeTULog2MaxSize();
-  UInt maxTBsize = (1<<log2maxTB);
-  const UInt minBlockArtSize = 8;
-  const UInt picWidth = pcPicYuvRec->getWidth();
-  const UInt picHeight = pcPicYuvRec->getHeight();
-  const UInt noCol = (picWidth>>log2maxTB);
-  const UInt noRows = (picHeight>>log2maxTB);
-  UInt64 *colSAD = (UInt64*)malloc(noCol*sizeof(UInt64));
-  UInt64 *rowSAD = (UInt64*)malloc(noRows*sizeof(UInt64));
-  UInt colIdx = 0;
-  UInt rowIdx = 0;
-  Pel p0, p1, p2, q0, q1, q2;
-  
-  Int qp = pcPic->getSlice(0)->getSliceQp();
-  Int bitdepthScale = 1 << (g_bitDepthY-8);
-  Int beta = TComLoopFilter::getBeta( qp ) * bitdepthScale;
-  const Int thr2 = (beta>>2);
-  const Int thr1 = 2*bitdepthScale;
-  UInt a = 0;
-  
-  memset(colSAD, 0, noCol*sizeof(UInt64));
-  memset(rowSAD, 0, noRows*sizeof(UInt64));
-  
-  if (maxTBsize > minBlockArtSize)
-  {
-    // Analyze vertical artifact edges
-    for(Int c = maxTBsize; c < picWidth; c += maxTBsize)
-    {
-      for(Int r = 0; r < picHeight; r++)
-      {
-        p2 = Rec[c-3];
-        p1 = Rec[c-2];
-        p0 = Rec[c-1];
-        q0 = Rec[c];
-        q1 = Rec[c+1];
-        q2 = Rec[c+2];
-        a = ((abs(p2-(p1<<1)+p0)+abs(q0-(q1<<1)+q2))<<1);
-        if ( thr1 < a && a < thr2)
-        {
-          colSAD[colIdx] += abs(p0 - q0);
-        }
-        Rec += stride;
-      }
-      colIdx++;
-      Rec = tempRec;
-    }
-    
-    // Analyze horizontal artifact edges
-    for(Int r = maxTBsize; r < picHeight; r += maxTBsize)
-    {
-      for(Int c = 0; c < picWidth; c++)
-      {
-        p2 = Rec[c + (r-3)*stride];
-        p1 = Rec[c + (r-2)*stride];
-        p0 = Rec[c + (r-1)*stride];
-        q0 = Rec[c + r*stride];
-        q1 = Rec[c + (r+1)*stride];
-        q2 = Rec[c + (r+2)*stride];
-        a = ((abs(p2-(p1<<1)+p0)+abs(q0-(q1<<1)+q2))<<1);
-        if (thr1 < a && a < thr2)
-        {
-          rowSAD[rowIdx] += abs(p0 - q0);
-        }
-      }
-      rowIdx++;
-    }
-  }
-  
-  UInt64 colSADsum = 0;
-  UInt64 rowSADsum = 0;
-  for(Int c = 0; c < noCol-1; c++)
-  {
-    colSADsum += colSAD[c];
-  }
-  for(Int r = 0; r < noRows-1; r++)
-  {
-    rowSADsum += rowSAD[r];
-  }
-  
-  colSADsum <<= 10;
-  rowSADsum <<= 10;
-  colSADsum /= (noCol-1);
-  colSADsum /= picHeight;
-  rowSADsum /= (noRows-1);
-  rowSADsum /= picWidth;
-  
-  UInt64 avgSAD = ((colSADsum + rowSADsum)>>1);
-  avgSAD >>= (g_bitDepthY-8);
-  
-  if ( avgSAD > 2048 )
-  {
-    avgSAD >>= 9;
-    Int offset = Clip3(2,6,(Int)avgSAD);
-    for (Int i=0; i<uiNumSlices; i++)
-    {
-      pcPic->getSlice(i)->setDeblockingFilterOverrideFlag(true);
-      pcPic->getSlice(i)->setDeblockingFilterDisable(false);
-      pcPic->getSlice(i)->setDeblockingFilterBetaOffsetDiv2( offset );
-      pcPic->getSlice(i)->setDeblockingFilterTcOffsetDiv2( offset );
-    }
-  }
-  else
-  {
-    for (Int i=0; i<uiNumSlices; i++)
-    {
-      pcPic->getSlice(i)->setDeblockingFilterOverrideFlag(false);
-      pcPic->getSlice(i)->setDeblockingFilterDisable(        pcPic->getSlice(i)->getPPS()->getPicDisableDeblockingFilterFlag() );
-      pcPic->getSlice(i)->setDeblockingFilterBetaOffsetDiv2( pcPic->getSlice(i)->getPPS()->getDeblockingFilterBetaOffsetDiv2() );
-      pcPic->getSlice(i)->setDeblockingFilterTcOffsetDiv2(   pcPic->getSlice(i)->getPPS()->getDeblockingFilterTcOffsetDiv2()   );
-    }
-  }
-  
-  free(colSAD);
-  free(rowSAD);
-}
-#endif
 #if H_MV
 Void TEncGOP::xSetRefPicListModificationsMvc( TComSlice* pcSlice, UInt uiPOCCurr, UInt iGOPid )
@@ -2846,5 +2522,5 @@
   {
     Int numModifications = 0;
-
+    
     for( Int k = 0; k < ge.m_numInterViewRefPics; k++ ) 
     {
@@ -2853,10 +2529,11 @@
 
     // set inter-view modifications
-    Bool isModified = false;
-    Int tempList[16];
-    for( Int k = 0; k < 16; k++ ) { tempList[k] = -1; }
-
     if( (maxRefListSize > 1) && (numModifications > 0) )
     {
+      refPicListModification->setRefPicListModificationFlagL( li, true );
+      Int tempList[16];
+      for( Int k = 0; k < 16; k++ ) { tempList[k] = -1; }
+
+      Bool isModified = false;
       for( Int k = 0; k < ge.m_numInterViewRefPics; k++ )
       {
@@ -2877,26 +2554,28 @@
         }
       }
-    }
-
-    refPicListModification->setRefPicListModificationFlagL( li, isModified );  
-
-    if( isModified )
-    {
-      Int temporalRefIdx = 0;
-      for( Int i = 0; i < pcSlice->getNumRefIdx( ( li == 0 ) ? REF_PIC_LIST_0 : REF_PIC_LIST_1 ); i++ )
-      {
-        if( tempList[i] >= 0 ) 
-        {
-          refPicListModification->setRefPicSetIdxL( li, i, tempList[i] );
-        }
-        else
-        {
-          refPicListModification->setRefPicSetIdxL( li, i, temporalRefIdx );
-          temporalRefIdx++;
-        }
-      }
-    }    
+      if( isModified )
+      {
+        Int temporalRefIdx = 0;
+        for( Int i = 0; i < pcSlice->getNumRefIdx( ( li == 0 ) ? REF_PIC_LIST_0 : REF_PIC_LIST_1 ); i++ )
+        {
+          if( tempList[i] >= 0 ) 
+          {
+            refPicListModification->setRefPicSetIdxL( li, i, tempList[i] );
+          }
+          else
+          {
+            refPicListModification->setRefPicSetIdxL( li, i, temporalRefIdx );
+            temporalRefIdx++;
+          }
+        }
+      }
+      else
+      {
+        refPicListModification->setRefPicListModificationFlagL( li, false );
+      }
+    }
   }
 }
 #endif
+
 //! \}
Index: branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncGOP.h
===================================================================
--- branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncGOP.h	(revision 437)
+++ branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncGOP.h	(revision 438)
@@ -108,4 +108,5 @@
 #endif
 #endif
+
   //--Adaptive Loop filter
   TEncSampleAdaptiveOffset*  m_pcSAO;
@@ -131,8 +132,4 @@
   Bool                    m_bufferingPeriodSEIPresentInAU;
   Bool                    m_pictureTimingSEIPresentInAU;
-#if K0180_SCALABLE_NESTING_SEI
-  Bool                    m_nestedBufferingPeriodSEIPresentInAU;
-  Bool                    m_nestedPictureTimingSEIPresentInAU;
-#endif
 #endif
 public:
@@ -144,4 +141,5 @@
   
   Void  init        ( TEncTop* pcTEncTop );
+
 #if H_MV
   Void  initGOP     ( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsInGOP);
@@ -150,5 +148,6 @@
   Void  compressGOP( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, TComList<TComPicYuv*>& rcListPicYuvRec, std::list<AccessUnit>& accessUnitsInGOP );
 #endif
-  Void  xAttachSliceDataToNalUnit (OutputNALUnit& rNalu, TComOutputBitstream*& rpcBitstreamRedirect);
+
+  Void xWriteTileLocationToSliceHeader (OutputNALUnit& rNalu, TComOutputBitstream*& rpcBitstreamRedirect, TComSlice*& rpcSlice);
 
 #if H_MV
@@ -168,8 +167,9 @@
   Void  printOutSummary      ( UInt uiNumAllPicCoded );
 #endif
+
   Void  preLoopFilterPicAll  ( TComPic* pcPic, UInt64& ruiDist, UInt64& ruiBits );
   
   TEncSlice*  getSliceEncoder()   { return m_pcSliceEncoder; }
-  NalUnitType getNalUnitType( Int pocCurr, Int lastIdr );
+  NalUnitType getNalUnitType( Int pocCurr );
   Void arrangeLongtermPicturesInRPS(TComSlice *, TComList<TComPic*>& );
 protected:
@@ -189,8 +189,4 @@
   SEIFramePacking*        xCreateSEIFramePacking();
   SEIDisplayOrientation*  xCreateSEIDisplayOrientation();
-
-#if J0149_TONE_MAPPING_SEI
-  SEIToneMappingInfo*     xCreateSEIToneMappingInfo();
-#endif
 
   Void xCreateLeadingSEIMessages (/*SEIMessages seiMessages,*/ AccessUnit &accessUnit, TComSPS *sps);
@@ -203,18 +199,10 @@
     m_pictureTimingSEIPresentInAU      = false;
   }
-#if K0180_SCALABLE_NESTING_SEI
-  Void xResetNestedSEIPresentFlags()
-  {
-    m_nestedBufferingPeriodSEIPresentInAU    = false;
-    m_nestedPictureTimingSEIPresentInAU      = false;
-  }
-#endif
-#endif
+#endif
+
 #if H_MV
    Void  xSetRefPicListModificationsMvc( TComSlice* pcSlice, UInt uiPOCCurr, UInt iGOPid );
 #endif
-#if L0386_DB_METRIC
-  Void dblMetric( TComPic* pcPic, UInt uiNumSlices );
-#endif
+
 };// END CLASS DEFINITION TEncGOP
 
Index: branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSampleAdaptiveOffset.cpp
===================================================================
--- branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSampleAdaptiveOffset.cpp	(revision 437)
+++ branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSampleAdaptiveOffset.cpp	(revision 438)
@@ -1677,4 +1677,12 @@
 #endif
 {
+#if SAO_CHROMA_LAMBDA 
+  m_dLambdaLuma    = dLambdaLuma;
+  m_dLambdaChroma  = dLambdaChroma;
+#else
+  m_dLambdaLuma    = dLambda;
+  m_dLambdaChroma  = dLambda;
+#endif
+
   if(m_bUseNIF)
   {
Index: branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSampleAdaptiveOffset.h
===================================================================
--- branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSampleAdaptiveOffset.h	(revision 437)
+++ branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSampleAdaptiveOffset.h	(revision 438)
@@ -57,4 +57,7 @@
 {
 private:
+  Double            m_dLambdaLuma;
+  Double            m_dLambdaChroma;
+
   TEncEntropy*      m_pcEntropyCoder;
   TEncSbac***       m_pppcRDSbacCoder;              ///< for CABAC
Index: branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSbac.h
===================================================================
--- branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSbac.h	(revision 437)
+++ branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSbac.h	(revision 438)
@@ -109,4 +109,5 @@
   Void  xWriteEpExGolomb     ( UInt uiSymbol, UInt uiCount );
   Void  xWriteCoefRemainExGolomb ( UInt symbol, UInt &rParam );
+  Void  xWriteTerminatingBit ( UInt uiBit );
   
   Void  xCopyFrom            ( TEncSbac* pSrc );
Index: branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 437)
+++ branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 438)
@@ -3209,11 +3209,4 @@
     UInt          uiBitsTempL0[MAX_NUM_REF];
 
-#if L0034_COMBINED_LIST_CLEANUP
-    TComMv        mvValidList1;
-    Int           refIdxValidList1 = 0;
-    UInt          bitsValidList1 = MAX_UINT;
-    UInt          costValidList1 = MAX_UINT;
-#endif
-
     xGetBlkBits( ePartSize, pcCU->getSlice()->isInterP(), iPartIdx, uiLastMode, uiMbBits);
     
@@ -3262,10 +3255,6 @@
         uiBitsTemp += m_auiMVPIdxCost[aaiMvpIdx[iRefList][iRefIdxTemp]][AMVP_MAX_NUM_CANDS];
 #if ZERO_MVD_EST
-#if L0034_COMBINED_LIST_CLEANUP
-        if ( iRefList == 0 || pcCU->getSlice()->getList1IdxToList0Idx( iRefIdxTemp ) < 0 )
-#else
         if ((iRefList != 1 || !pcCU->getSlice()->getNoBackPredFlag()) &&
             (pcCU->getSlice()->getNumRefIdx(REF_PIC_LIST_C) <= 0 || pcCU->getSlice()->getRefIdxOfLC(eRefPicList, iRefIdxTemp)>=0))
-#endif
         {
           uiZeroMvdBitsTemp = uiBitsTemp;
@@ -3287,29 +3276,4 @@
         
 #if GPB_SIMPLE_UNI
-#if L0034_COMBINED_LIST_CLEANUP
-        if ( iRefList == 1 )    // list 1
-        {
-          if ( pcCU->getSlice()->getList1IdxToList0Idx( iRefIdxTemp ) >= 0 )
-          {
-            cMvTemp[1][iRefIdxTemp] = cMvTemp[0][pcCU->getSlice()->getList1IdxToList0Idx( iRefIdxTemp )];
-            uiCostTemp = uiCostTempL0[pcCU->getSlice()->getList1IdxToList0Idx( iRefIdxTemp )];
-            /*first subtract the bit-rate part of the cost of the other list*/
-            uiCostTemp -= m_pcRdCost->getCost( uiBitsTempL0[pcCU->getSlice()->getList1IdxToList0Idx( iRefIdxTemp )] );
-            /*correct the bit-rate part of the current ref*/
-            m_pcRdCost->setPredictor  ( cMvPred[iRefList][iRefIdxTemp] );
-            uiBitsTemp += m_pcRdCost->getBits( cMvTemp[1][iRefIdxTemp].getHor(), cMvTemp[1][iRefIdxTemp].getVer() );
-            /*calculate the correct cost*/
-            uiCostTemp += m_pcRdCost->getCost( uiBitsTemp );
-          }
-          else
-          {
-            xMotionEstimation ( pcCU, pcOrgYuv, iPartIdx, eRefPicList, &cMvPred[iRefList][iRefIdxTemp], iRefIdxTemp, cMvTemp[iRefList][iRefIdxTemp], uiBitsTemp, uiCostTemp );
-          }
-        }
-        else
-        {
-          xMotionEstimation ( pcCU, pcOrgYuv, iPartIdx, eRefPicList, &cMvPred[iRefList][iRefIdxTemp], iRefIdxTemp, cMvTemp[iRefList][iRefIdxTemp], uiBitsTemp, uiCostTemp );
-        }
-#else
         if ( pcCU->getSlice()->getNumRefIdx(REF_PIC_LIST_C) > 0)
         {
@@ -3353,5 +3317,4 @@
           }        
         }
-#endif
 #else
         xMotionEstimation ( pcCU, pcOrgYuv, iPartIdx, eRefPicList, &cMvPred[iRefList][iRefIdxTemp], iRefIdxTemp, cMvTemp[iRefList][iRefIdxTemp], uiBitsTemp, uiCostTemp );
@@ -3360,30 +3323,4 @@
         xCheckBestMVP(pcCU, eRefPicList, cMvTemp[iRefList][iRefIdxTemp], cMvPred[iRefList][iRefIdxTemp], aaiMvpIdx[iRefList][iRefIdxTemp], uiBitsTemp, uiCostTemp);
 
-#if L0034_COMBINED_LIST_CLEANUP
-        if ( iRefList == 0 )
-        {
-          uiCostTempL0[iRefIdxTemp] = uiCostTemp;
-          uiBitsTempL0[iRefIdxTemp] = uiBitsTemp;
-        }
-        if ( uiCostTemp < uiCost[iRefList] )
-        {
-          uiCost[iRefList] = uiCostTemp;
-          uiBits[iRefList] = uiBitsTemp; // storing for bi-prediction
-
-          // set motion
-          cMv[iRefList]     = cMvTemp[iRefList][iRefIdxTemp];
-          iRefIdx[iRefList] = iRefIdxTemp;
-        }
-
-        if ( iRefList == 1 && uiCostTemp < costValidList1 && pcCU->getSlice()->getList1IdxToList0Idx( iRefIdxTemp ) < 0 )
-        {
-          costValidList1 = uiCostTemp;
-          bitsValidList1 = uiBitsTemp;
-
-          // set motion
-          mvValidList1     = cMvTemp[iRefList][iRefIdxTemp];
-          refIdxValidList1 = iRefIdxTemp;
-        }
-#else
         if(pcCU->getSlice()->getNumRefIdx(REF_PIC_LIST_C) > 0 && !pcCU->getSlice()->getNoBackPredFlag())
         {
@@ -3435,5 +3372,4 @@
             }
           }
-#endif
       }
     }
@@ -3499,33 +3435,8 @@
         
         Int         iRefList    = iIter % 2;
-#if L0034_COMBINED_LIST_CLEANUP
-        if ( m_pcEncCfg->getUseFastEnc() )
-        {
-          if( uiCost[0] <= uiCost[1] )
-          {
-            iRefList = 1;
-          }
-          else
-          {
-            iRefList = 0;
-          }
-        }
-        else if ( iIter == 0 )
-        {
-          iRefList = 0;
-        }
-        if ( iIter == 0 && !pcCU->getSlice()->getMvdL1ZeroFlag())
-        {
-          pcCU->getCUMvField(RefPicList(1-iRefList))->setAllMv( cMv[1-iRefList], ePartSize, uiPartAddr, 0, iPartIdx );
-          pcCU->getCUMvField(RefPicList(1-iRefList))->setAllRefIdx( iRefIdx[1-iRefList], ePartSize, uiPartAddr, 0, iPartIdx );
-          TComYuv*  pcYuvPred = &m_acYuvPred[1-iRefList];
-          motionCompensation ( pcCU, pcYuvPred, RefPicList(1-iRefList), iPartIdx );
-        }
-#else
         if ( m_pcEncCfg->getUseFastEnc() && (pcCU->getSlice()->getNoBackPredFlag() || (pcCU->getSlice()->getNumRefIdx(REF_PIC_LIST_C) > 0 && pcCU->getSlice()->getRefIdxOfL0FromRefIdxOfL1(0)==0 )) )
         {
           iRefList = 1;
         }
-#endif
         RefPicList  eRefPicList = ( iRefList ? REF_PIC_LIST_1 : REF_PIC_LIST_0 );
 
@@ -3662,15 +3573,8 @@
     UInt uiMEBits = 0;
     // Set Motion Field_
-#if L0034_COMBINED_LIST_CLEANUP
-    cMv[1] = mvValidList1;
-    iRefIdx[1] = refIdxValidList1;
-    uiBits[1] = bitsValidList1;
-    uiCost[1] = costValidList1;
-#else
     if ( pcCU->getSlice()->getNoBackPredFlag() || (pcCU->getSlice()->getNumRefIdx(REF_PIC_LIST_C) > 0 && pcCU->getSlice()->getRefIdxOfL0FromRefIdxOfL1(0)==0 ) )
     {
       uiCost[1] = MAX_UINT;
     }
-#endif
 #if AMP_MRG
     if (bTestNormalMC)
@@ -4618,5 +4522,5 @@
     while( pcCU->getWidth(0) > (pcCU->getSlice()->getSPS()->getMaxTrSize()<<uiTrLevel) ) uiTrLevel++;
   }
-  UInt uiMaxTrMode = 1 + uiTrLevel;
+  UInt uiMaxTrMode = pcCU->getSlice()->getSPS()->getMaxTrDepth() + uiTrLevel;
   
   while((uiWidth>>uiMaxTrMode) < (g_uiMaxCUWidth>>g_uiMaxCUDepth)) uiMaxTrMode--;
Index: branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSlice.cpp
===================================================================
--- branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 437)
+++ branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 438)
@@ -414,5 +414,4 @@
   eSliceType = (pocLast == 0 || pocCurr % m_pcCfg->getIntraPeriod() == 0 || m_pcGOPEncoder->getGOPSize() == 0) ? I_SLICE : eSliceType;
 #endif
-
   rpcSlice->setSliceType        ( eSliceType );
 #endif
@@ -439,13 +438,4 @@
 #endif
 
-#if L0386_DB_METRIC
-  if ( m_pcCfg->getDeblockingFilterMetric() )
-  {
-    rpcSlice->setDeblockingFilterOverrideFlag(true);
-    rpcSlice->setDeblockingFilterDisable(false);
-    rpcSlice->setDeblockingFilterBetaOffsetDiv2( 0 );
-    rpcSlice->setDeblockingFilterTcOffsetDiv2( 0 );
-  } else
-#endif
   if (rpcSlice->getPPS()->getDeblockingFilterControlPresentFlag())
   {
@@ -1233,5 +1223,5 @@
  \retval rpcBitstream  bitstream class
  */
-Void TEncSlice::encodeSlice   ( TComPic*& rpcPic, TComOutputBitstream* pcSubstreams )
+Void TEncSlice::encodeSlice   ( TComPic*& rpcPic, TComOutputBitstream* pcBitstream, TComOutputBitstream* pcSubstreams )
 {
   UInt       uiCUAddr;
@@ -1413,5 +1403,37 @@
       }
       {
-        UInt numStartCodeEmulations = pcSubstreams[uiSubStrm].countStartCodeEmulations();
+          UInt uiCounter = 0;
+          vector<uint8_t>& rbsp   = pcSubstreams[uiSubStrm].getFIFO();
+          for (vector<uint8_t>::iterator it = rbsp.begin(); it != rbsp.end();)
+          {
+            /* 1) find the next emulated 00 00 {00,01,02,03}
+             * 2a) if not found, write all remaining bytes out, stop.
+             * 2b) otherwise, write all non-emulated bytes out
+             * 3) insert emulation_prevention_three_byte
+             */
+            vector<uint8_t>::iterator found = it;
+            do
+            {
+              /* NB, end()-1, prevents finding a trailing two byte sequence */
+              found = search_n(found, rbsp.end()-1, 2, 0);
+              found++;
+              /* if not found, found == end, otherwise found = second zero byte */
+              if (found == rbsp.end())
+              {
+                break;
+              }
+              if (*(++found) <= 3)
+              {
+                break;
+              }
+            } while (true);
+            it = found;
+            if (found != rbsp.end())
+            {
+              it++;
+              uiCounter++;
+            }
+          }
+        
         UInt uiAccumulatedSubstreamLength = 0;
         for (Int iSubstrmIdx=0; iSubstrmIdx < iNumSubstreams; iSubstrmIdx++)
@@ -1421,5 +1443,5 @@
         // add bits coded in previous dependent slices + bits coded so far
         // add number of emulation prevention byte count in the tile
-        pcSlice->addTileLocation( ((pcSlice->getTileOffstForMultES() + uiAccumulatedSubstreamLength - uiBitsOriginallyInSubstreams) >> 3) + numStartCodeEmulations );
+        pcSlice->addTileLocation( ((pcSlice->getTileOffstForMultES() + uiAccumulatedSubstreamLength - uiBitsOriginallyInSubstreams) >> 3) + uiCounter );
       }
     }
Index: branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSlice.h
===================================================================
--- branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSlice.h	(revision 437)
+++ branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncSlice.h	(revision 438)
@@ -122,5 +122,5 @@
   Void    precompressSlice    ( TComPic*& rpcPic                                );      ///< precompress slice for multi-loop opt.
   Void    compressSlice       ( TComPic*& rpcPic                                );      ///< analysis stage of slice
-  Void    encodeSlice         ( TComPic*& rpcPic, TComOutputBitstream* pcSubstreams  );
+  Void    encodeSlice         ( TComPic*& rpcPic, TComOutputBitstream* rpcBitstream, TComOutputBitstream* pcSubstreams  );
   
   // misc. functions
Index: branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncTop.cpp	(revision 437)
+++ branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncTop.cpp	(revision 438)
@@ -81,4 +81,5 @@
   m_pcBitCounters          = NULL;
   m_pcRdCosts              = NULL;
+
 #if H_MV
   m_ivPicLists = NULL;
@@ -95,4 +96,5 @@
 Void TEncTop::create ()
 {
+
 #if !H_MV
   // initialize global variables
@@ -286,4 +288,5 @@
 Void TEncTop::init()
 {
+
   // initialize SPS
   xInitSPS();
@@ -345,4 +348,5 @@
 }
 #endif
+
 Void TEncTop::deletePicBuffer()
 {
@@ -371,11 +375,11 @@
  \retval  iNumEncoded         number of encoded pictures
  */
+Void TEncTop::encode(Bool flush, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded 
 #if H_MV
-Void TEncTop::encode(Bool flush, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded , Int gopId )
-{
-#else
-Void TEncTop::encode(Bool flush, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded )
-{
-#endif
+                     , Int gopId 
+#endif               
+                     )
+{
+
 #if H_3D
   TComPic* picLastCoded = getPic( getGOPEncoder()->getPocLastCoded() );
@@ -385,4 +389,5 @@
   }
 #endif
+
 #if H_MV
   if( gopId == 0)
@@ -438,7 +443,9 @@
   m_iNumPicRcvd       = 0;
   m_uiNumAllPicCoded += iNumEncoded;
+
 #if H_MV
 }
 #endif
+
 }
 
@@ -540,15 +547,6 @@
   m_cSPS.setMaxCUHeight   ( g_uiMaxCUHeight     );
   m_cSPS.setMaxCUDepth    ( g_uiMaxCUDepth      );
-
-  Int minCUSize = m_cSPS.getMaxCUWidth() >> ( m_cSPS.getMaxCUDepth()-g_uiAddCUDepth );
-  Int log2MinCUSize = 0;
-  while(minCUSize > 1)
-  {
-    minCUSize >>= 1;
-    log2MinCUSize++;
-  }
-
-  m_cSPS.setLog2MinCodingBlockSize(log2MinCUSize);
-  m_cSPS.setLog2DiffMaxMinCodingBlockSize(m_cSPS.getMaxCUDepth()-g_uiAddCUDepth);
+  m_cSPS.setMinTrDepth    ( 0                   );
+  m_cSPS.setMaxTrDepth    ( 1                   );
   
   m_cSPS.setPCMLog2MinSize (m_uiPCMLog2MinSize);
@@ -565,7 +563,6 @@
 
   m_cSPS.setMaxTrSize   ( 1 << m_uiQuadtreeTULog2MaxSize );
-#if !L0034_COMBINED_LIST_CLEANUP
+  
   m_cSPS.setUseLComb    ( m_bUseLComb           );
-#endif
   
   Int i;
@@ -719,20 +716,5 @@
   m_cPPS.setOutputFlagPresentFlag( false );
   m_cPPS.setSignHideFlag(getSignHideFlag());
-#if L0386_DB_METRIC
-  if ( getDeblockingFilterMetric() )
-  {
-    m_cPPS.setDeblockingFilterControlPresentFlag (true);
-    m_cPPS.setDeblockingFilterOverrideEnabledFlag(true);
-    m_cPPS.setPicDisableDeblockingFilterFlag(false);
-    m_cPPS.setDeblockingFilterBetaOffsetDiv2(0);
-    m_cPPS.setDeblockingFilterTcOffsetDiv2(0);
-  } 
-  else
-  {
   m_cPPS.setDeblockingFilterControlPresentFlag (m_DeblockingFilterControlPresent );
-  }
-#else
-  m_cPPS.setDeblockingFilterControlPresentFlag (m_DeblockingFilterControlPresent );
-#endif
   m_cPPS.setLog2ParallelMergeLevelMinus2   (m_log2ParallelMergeLevelMinus2 );
   m_cPPS.setCabacInitPresentFlag(CABAC_INIT_PRESENT_FLAG);
@@ -1006,38 +988,5 @@
   }
 #endif
-
-}
-
-#if L0208_SOP_DESCRIPTION_SEI
-Int TEncTop::getReferencePictureSetIdxForSOP(TComSlice* slice, Int POCCurr, Int GOPid )
-{
-  int rpsIdx = GOPid;
-
-  for(Int extraNum=m_iGOPSize; extraNum<m_extraRPSs+m_iGOPSize; extraNum++)
-  {    
-    if(m_uiIntraPeriod > 0 && getDecodingRefreshType() > 0)
-    {
-      Int POCIndex = POCCurr%m_uiIntraPeriod;
-      if(POCIndex == 0)
-      {
-        POCIndex = m_uiIntraPeriod;
-      }
-      if(POCIndex == m_GOPList[extraNum].m_POC)
-      {
-        rpsIdx = extraNum;
-      }
-    }
-    else
-    {
-      if(POCCurr==m_GOPList[extraNum].m_POC)
-      {
-        rpsIdx = extraNum;
-      }
-    }
-  }
-
-  return rpsIdx;
-}
-#endif
+}
 
 Void  TEncTop::xInitPPSforTiles()
@@ -1120,4 +1069,5 @@
   }
 }
+
 #if H_MV
 Void TEncTop::printSummary( Int numAllPicCoded )
@@ -1182,3 +1132,4 @@
 }
 #endif
+
 //! \}
Index: branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncTop.h	(revision 437)
+++ branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/TEncTop.h	(revision 438)
@@ -63,4 +63,6 @@
 // Class definition
 // ====================================================================================================================
+
+
 
 /// encoder class
@@ -131,4 +133,5 @@
   TEncAnalyze             m_cAnalyzeB;  
 #endif
+
 protected:
   Void  xGetNewPicBuffer  ( TComPic*& rpcPic );           ///< get picture buffer which will be processed
@@ -145,8 +148,11 @@
   Void      create          ();
   Void      destroy         ();
+
   Void      init            ();
+
 #if H_MV  
   TComPicLists* getIvPicLists() { return m_ivPicLists; }
 #endif
+
   Void      deletePicBuffer ();
 
@@ -156,4 +162,5 @@
   Void      initNewPic(TComPicYuv* pcPicYuvOrg);
 #endif
+
   // -------------------------------------------------------------------------------------------------------------------
   // member access functions
@@ -188,8 +195,6 @@
   TComPPS*                getPPS                () { return  &m_cPPS;                 }
   Void selectReferencePictureSet(TComSlice* slice, Int POCCurr, Int GOPid );
-#if L0208_SOP_DESCRIPTION_SEI
-  Int getReferencePictureSetIdxForSOP(TComSlice* slice, Int POCCurr, Int GOPid );
-#endif
   TComScalingList*        getScalingList        () { return  &m_scalingList;         }
+
 #if H_MV
   TEncAnalyze*            getAnalyzeAll         () { return &m_cAnalyzeAll; }
@@ -205,4 +210,6 @@
   Void                    setIvPicLists         ( TComPicLists* picLists) { m_ivPicLists = picLists; }
 #endif
+
+
   // -------------------------------------------------------------------------------------------------------------------
   // encoder function
@@ -210,16 +217,17 @@
 
   /// encode several number of pictures until end-of-sequence
-#if H_MV
-  Void encode( Bool bEos, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded  , Int gopId  );  
-#else
   Void encode( Bool bEos, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut,
-              std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded );  
-#endif
-
-#if H_MV
-  Void printSummary      ( Int numAllPicCoded ); 
+              std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded 
+#if H_MV
+              , Int gopId 
+#endif        
+              );  
+
+#if H_MV
+  void printSummary      ( Int numAllPicCoded ); 
 #else
   void printSummary() { m_cGOPEncoder.printOutSummary (m_uiNumAllPicCoded); }
 #endif
+
 };
 
Index: branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/WeightPredAnalysis.cpp
===================================================================
--- branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/WeightPredAnalysis.cpp	(revision 437)
+++ branches/HTM-DEV-0.2-dev/source/Lib/TLibEncoder/WeightPredAnalysis.cpp	(revision 438)
@@ -235,15 +235,11 @@
         Int offset = (Int)( ((currDC<<log2Denom) - ((Int64)weight * refDC) + (Int64)realOffset) >> realLog2Denom );
 
-        // Chroma offset range limitation
+        // Chroma offset range limination
         if(comp)
         {
-          Int pred = ( 128 - ( ( 128*weight)>>(log2Denom) ) );
+          Int shift = 1 << (g_bitDepthC - 1);
+          Int pred = ( shift - ( ( shift*weight)>>(log2Denom) ) );
           Int deltaOffset = Clip3( -512, 511, (offset - pred) );    // signed 10bit
           offset = Clip3( -128, 127, (deltaOffset + pred) );        // signed 8bit
-        }
-        // Luma offset range limitation
-        else
-        {
-          offset = Clip3( -128, 127, offset);
         }
 
